""" Python stock par défaut en mémoire les valeurs de 0 à 256
car elles sont très souvent utilisées. A partir de 257, le stockage en mémoire
se fait de façon dynamique (à la demande) donc sur un autre espace mémoire """

import ctypes

l = [252, 253, 254]
ad_l = id(l) # Adresse de l'instance de classe (structure)
ad0 = id(l[0]) # Adresse du premier élément de la liste (contenu)

print(f"Adresse de l'instance de classe list : 0x{ad_l:x}" )
print(f"Information à cette adresse -> {ctypes.cast( ad_l, ctypes.py_object).value}")

print("-"*15)

print("Adresse des éléments de la liste :")
for i in range( len(l) ):
    print(f"Adresse   l[{i}]: 0x{id(l[i]):x} -> Valeur : {l[i]}" )

print("-"*15)

adresse = id( l[0] )
print("Adresses mémoire calculées avec une incrémentation de 32 octets :")

for ad in range( adresse, adresse+6*0x20, 32 ):
    val = ctypes.cast( ad, ctypes.py_object).value
    print(f"Adresse ....... 0x{ad:x} -> Valeur : {val}" )

print("-"*15)

print("Information à une adresse donnée")
ad_1 = id(1)
print(f"Adresse mémoire du chiffre 1 : {ad_1:x}")